from main_functions import *
from compressed import *
from random import randint
from sage.all import proof
import time

proof.all(False)

lam = 128
a,b,c,f = set_param(lam)

print("Security parameter:",lam)

p = (2**(a+2))*(3**b)*(5**c)*f - 1

Fp = GF(p)
Fp2 = GF(p**2, name='sqrtminus', modulus = x**2+1)
Fp2.inject_variables()

strategy = optimal_strategy_3(b-1,12,8)
strategy_for_2dim = optimal_strategy_3(a-2,42,27)

#compressed = 1-> compressed
#other -> original version
compressed = 1

if compressed == 1:
    print("**Compressed version**")

pub_param = generate_pubparam(a,b,c,sqrtminus,Fp,Fp2,p)

run = 10
pubkeygen = 0
encry = 0
decry = 0

for i in range(run):

    T = time.time()
    pubkey,Alice_secret = generate_pubkey(a,b,c,pub_param,strategy,strategy_for_2dim,sqrtminus,Fp,Fp2,p)
    if compressed == 1:
        pubkey_comp,Alice_secret = compressed_pubkey(pubkey,a,b,c,Alice_secret,p,Fp,Fp2)
    pubkeygen += time.time() - T

    mu = randint(0,5**(c-1)-1) * 5 + randint(1,4)

    T = time.time()
    if compressed == 1:
        pubkey = decomp_pubkey(pubkey_comp,a,b,c,p,Fp,Fp2)
    cipher = encrypt(a,b,c,strategy,sqrtminus,Fp,Fp2,pubkey,mu)
    if compressed == 1:
        cipher_comp = compressed_cipher(cipher,a,c,p,Fp,Fp2)
    encry += time.time() - T

    T = time.time()
    if compressed == 1:
        cipher = decomp_cipher(cipher_comp,Alice_secret,a,c,p,Fp,Fp2)
    mu2 = decrypt(a,b,c,strategy_for_2dim,sqrtminus,Fp,Fp2,cipher,Alice_secret)
    decry += time.time() - T


    if (mu != mu2) and (5**c-mu2 != mu):
        print("Something is wrong.")
    else:
        print(i)

print("run is ", run)

print("Key gen:",pubkeygen / run)
print("Encryption:",encry / run)
print("Decryption:",decry / run)
